// pelosano.cpp - Implementazione di <pelosano.h> -


#include "dos.h"
#include "time.h"
#include "stdio.h"
#include "conio.h"
#include "ctype.h"
#include "stdlib.h"
#include "string.h"
#include "c:\pelosano\pelosano.h"


// ---  Variabili Globali ---

// Testo del titolo
char titoloPrimaRiga[COLONNE];
char titoloSecondaRiga[COLONNE];

// Tabella dei nomi degli archivi
char nomeFilePrezziario[MAX_LUNG_NOME_FILE];
char nomeDirettorioArchivi[MAX_LUNG_NOME_FILE];

char nomiFileMagazzino[MAX_PREZZIARI][MAX_LUNG_NOME_FILE];
char nomiFileTotaliParziali[MAX_PREZZIARI][MAX_LUNG_NOME_FILE];

// Prezziari noti
int nPrezziari;
Prezziario Menu[MAX_PREZZIARI];

// Ordinazione corrente
Ordinazione listaOrdini[MAX_PREZZIARI];
unsigned long totaliParziali[MAX_PREZZIARI];

// Varie
unsigned long numeroOrdine;
unsigned long totaleOrdine;
char strTotaleOrdine[MAX_LUNG_NOMI];
int primaStampa = 1;




/////////////////////////////////////////////////////////////////////////////
//                      G E S T I O N E   F I L E S
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// LeggiProssimaLinea
int LeggiProssimaLinea(FILE* pFile, char* pBuffer)
{
	char ch;
	char* pPunt = pBuffer;
	int caratteriLetti = 0;
	size_t letture = fread(&ch,sizeof(char),1,pFile);

	while ((letture>0) && (ch!=A_CAPO))
	{
		*pPunt = ch;
		pPunt++;
		caratteriLetti++;
		letture = fread(&ch,sizeof(char),1,pFile);
	}

	// Terminatore
	pBuffer[caratteriLetti] = '\0';

	// Ritorna 0 se il file e' terminato
	return (letture>0);
}

/////////////////////////////////////////////////////////////////////////////
// LeggiConfigurazione
void LeggiConfigurazione()
{
	numeroOrdine = 0;
	strcpy(titoloSecondaRiga,TESTO_TITOLO_2aRIGA);

	FILE* cfg;
	if((cfg = fopen(NOME_FILE_CONFIGURAZIONE,"rt"))==NULL)
		return;

	// Leggi il codice dell'ultima ordinazione
	int fineFile;
	char linea[256];
	char buffer[256];

	do {
		fineFile = !LeggiProssimaLinea(cfg,linea);

		// E' una linea vuota?
		if (strlen(linea)>0)
		{
			// E' il codice dell'ultima ordinazione?
			strncpy(buffer,linea,strlen(NOME_ULTIMO_ORDINE));
			buffer[strlen(NOME_ULTIMO_ORDINE)] = '\0';

			if (strcmp(buffer,NOME_ULTIMO_ORDINE)==0)
			{
				stringa strOrdine;
				strcpy(strOrdine,&linea[strlen(NOME_ULTIMO_ORDINE)]);
				numeroOrdine = atol(strOrdine);
			}

			// E' il testo della seconda riga del titolo?
			strncpy(buffer,linea,strlen(NOME_SECONDA_RIGA));
			buffer[strlen(NOME_SECONDA_RIGA)] = '\0';

			if (strcmp(buffer,NOME_SECONDA_RIGA)==0)
				strcpy(titoloSecondaRiga,&linea[strlen(NOME_SECONDA_RIGA)]);
		}

	} while (!fineFile);

	fclose(cfg);
}

/////////////////////////////////////////////////////////////////////////////
// SalvaConfigurazione
int SalvaConfigurazione()
{
	FILE* cfg;
	if((cfg = fopen(NOME_FILE_CONFIGURAZIONE,"wt"))==NULL)
		return 0;

	// Scrivi il titolo
	char linea[256];

	strcpy(linea,NOME_SECONDA_RIGA);
	strcat(linea,titoloSecondaRiga);
	fwrite(linea,sizeof(char),strlen(linea),cfg);

	// Scrivi un CR+LF
	char ch = A_CAPO;
	fwrite(&ch,1,1,cfg);

	// Scrivi l'ultimo ordine
	strcpy(linea,NOME_ULTIMO_ORDINE);
	ultoa(numeroOrdine,&linea[strlen(NOME_ULTIMO_ORDINE)],10);
	fwrite(linea,sizeof(char),strlen(linea),cfg);

	// Scrivi un CR+LF
	fwrite(&ch,1,1,cfg);

	fclose(cfg);
	return 1;
}

/////////////////////////////////////////////////////////////////////////////
// LeggiPrezziario
int LeggiPrezziario()
{
	nPrezziari = 0;
	FILE* filePrezziario;

	if ((filePrezziario = fopen(nomeFilePrezziario,"rt"))==NULL)
		return 0;

	char linea[256];
	char buffer[256];
	char strPrezzo[MAX_LUNG_NOMI];
	int fineFile, trovato, nVoce, pt, ptAux;

	do {
		fineFile = !LeggiProssimaLinea(filePrezziario,linea);

		// E' una nuova categoria?
		if (strlen(linea)>0)
		{
			strncpy(buffer,linea,strlen(NOME_CATEGORIA));
			buffer[strlen(NOME_CATEGORIA)] = '\0';

			if ((strcmp(buffer,NOME_CATEGORIA)==0)
				&& (nPrezziari<MAX_CATEGORIE))
			{
				nVoce = 0;
				nPrezziari++;
				Menu[nPrezziari-1].m_nVoci = 0;
				strcat(Menu[nPrezziari-1].m_nome,
						&linea[strlen(NOME_CATEGORIA)]);

				// C'e' gia' una categoria con questo nome?
				// (Controllo eseguito sui primi otto caratteri)
				int j = 0;
				trovato = 0;
				while ((j<nPrezziari-1) && (!trovato))
				{
					trovato = (strncmpi(Menu[j].m_nome,
										Menu[nPrezziari-1].m_nome,8)==0);
					j++;
				}

				if (trovato)
				{
					// Errore di Sintassi...
					nPrezziari = 0;
					return 1;
				}
			}
			else
				if (nPrezziari>0)
				{
					// Aggiungi l'articolo all'ultimo menu
					pt = 0;
					while ((linea[pt]!=SEPARATORE) && (pt<strlen(linea)))
					{
						if (pt<MAX_LUNG_NOMI)
							Menu[nPrezziari-1].m_prezzo[nVoce].m_nome[pt]
															 = linea[pt];
						pt++;
					}

					// Trascura i separatori
					while ((linea[pt]==SEPARATORE) && (pt<strlen(linea)))
						pt++;

					// Leggi il prezzo
					for(int i=0; i<MAX_LUNG_NOMI; i++)
						strPrezzo[i] = ' ';
					ptAux = pt;
					while ((linea[pt]!=SEPARATORE) && (pt<strlen(linea)))
					{
						strPrezzo[pt-ptAux] = linea[pt];
						pt++;
					}
					Menu[nPrezziari-1].m_prezzo[nVoce].m_prezzo =
													 atol(strPrezzo);
					nVoce++;
					Menu[nPrezziari-1].m_nVoci++;
				}
		}

	} while (!fineFile);

	return 1;
}

/////////////////////////////////////////////////////////////////////////////
// ComponiNomiFileArchivio
void ComponiNomiFileArchivio()
{
	char nomeFile[9];

	for (int i=0; i<nPrezziari; i++)
	{
		// Componi il nuovo nome
		if (strlen(Menu[i].m_nome)==0)
			strcpy(nomeFile,NOME_FILE_ARCHIVI);
		else
		{
			strncpy(nomeFile,Menu[i].m_nome,8);
			if (strlen(Menu[i].m_nome)>8)
				nomeFile[9] = '\0';
		}

		strcpy(nomiFileMagazzino[i],nomeDirettorioArchivi);
		strcat(nomiFileMagazzino[i],nomeFile);
		strcat(nomiFileMagazzino[i],ESTENSIONE_FILE_MAGAZZINO);

		strcpy(nomiFileTotaliParziali[i],nomeDirettorioArchivi);
		strcat(nomiFileTotaliParziali[i],nomeFile);
		strcat(nomiFileTotaliParziali[i],ESTENSIONE_FILE_TOTALI);
}
}

/////////////////////////////////////////////////////////////////////////////
// AggiornaArchivi
int AggiornaArchivi()
{
	stringa buffer;
	FILE* fileTotali;
	FILE* fileMagazzino;

	for (int i=0; i<nPrezziari; i++)
		if ((totaliParziali[i]>0) || (strlen(listaOrdini[i].m_tipoOrdine)>0))
		{
			// Aggiorna il file di magazzino
			if ((fileMagazzino = fopen(nomiFileMagazzino[i],"at"))==NULL)
				return 0;

			// Scrivi data e ora
			fprintf(fileMagazzino,"%s%c%s%c",listaOrdini[i].m_data,
											 SEPARATORE,
											 listaOrdini[i].m_ora,
											 SEPARATORE);

			// Scrivi il codice dell'ordinazione
			ultoa(numeroOrdine,buffer,10);

			// E' un ordine interno?
			if (strlen(listaOrdini[i].m_tipoOrdine)>0)
				strcat(buffer,SUFFISSO_CODICE_INTERNO);

			fprintf(fileMagazzino,buffer);

			//Scrivi le quantita' ordinate
			for (int j=0; j<Menu[i].m_nVoci; j++)
			{
				ultoa(listaOrdini[i].m_articolo[j].m_quantita,buffer,10);
				fprintf(fileMagazzino,"%c%s",SEPARATORE,buffer);
			}

			// Scrivi il codice dell'ordine
			if (strlen(listaOrdini[i].m_tipoOrdine)>0)
				fprintf(fileMagazzino,"%c%s",SEPARATORE,listaOrdini[i].m_tipoOrdine);

			fprintf(fileMagazzino,"\n");
			fclose(fileMagazzino);

			// Aggiorna il file dei prezzi
			if ((fileTotali = fopen(nomiFileTotaliParziali[i],"at"))==NULL)
				return 0;

			// Scrivi data e ora
			fprintf(fileTotali,"%s%c%s%c",listaOrdini[i].m_data,
										  SEPARATORE,
										  listaOrdini[i].m_ora,
										  SEPARATORE);

			// Scrivi il codice dell'ordinazione
			ultoa(numeroOrdine,buffer,10);

			// E' un ordine interno?
			if (strlen(listaOrdini[i].m_tipoOrdine)>0)
				strcat(buffer,SUFFISSO_CODICE_INTERNO);

			fprintf(fileTotali,buffer);

			//Scrivi i totali parziali
			for (j=0; j<Menu[i].m_nVoci; j++)
			{
				ultoa(listaOrdini[i].m_articolo[j].m_quantita*
						Menu[i].m_prezzo[j].m_prezzo,buffer,10);
				fprintf(fileTotali,"%c%s",SEPARATORE,buffer);
			}

			// Scrivi il codice dell'ordine
			if (strlen(listaOrdini[i].m_tipoOrdine)>0)
				fprintf(fileTotali,"%c%s",SEPARATORE,listaOrdini[i].m_tipoOrdine);

			fprintf(fileTotali,"\n");
			fclose(fileTotali);
		}

	return 1;
}





/////////////////////////////////////////////////////////////////////////////
//                 S T A M P A  O R D I N A Z I O N E
/////////////////////////////////////////////////////////////////////////////
// InserisciPunti
char* InserisciPunti(char* numero)
{
	char buffer[20];

	strcpy(buffer, numero);
	strcpy(numero, "");

	int primeCifre = strlen(buffer) % 3;
	strncat(numero, buffer, primeCifre);

	int pos = primeCifre;
	while (pos<strlen(buffer))
	{
		if (pos>0)
			strcat(numero,".");

		strncat(numero, &buffer[pos], 3);
		pos += 3;
	}

    return(numero);
}



/////////////////////////////////////////////////////////////////////////////
// Imposta Stampante
void ImpostaStampante()
{
	clrscr();
	printf("ͻ");
	printf("                          IMPOSTAZIONE DELLA STAMPANTE                        ");
	printf("ͼ");
	printf("\n\n");
	printf("Lunghezza dello scontrino in pollici: ");
	printf("%d", LUNGHEZZA_SCONTRINO);
	printf("\n\n");
	printf("Modificare? <Si, No>");

	int lunghezza = LUNGHEZZA_SCONTRINO;
	char c = getch();
	if((c == 'S') || (c == 's'))
	{
		printf("  ..... Nuova lunghezza: ");
		scanf("%d", &lunghezza);
	}

	// imposta lunghezza scontrino
	fprintf(STDPRN, "%c", ESC);
	fprintf(STDPRN, "%c", 'C');
	fprintf(STDPRN, "%c", NUL);
	fprintf(STDPRN, "%c", char(lunghezza));
}


// Stampa Ordinazioni
void StampaOrdinazioni()
{
	int		i,j;
	char	riga[50];
	char	buffer[80];
	char	prezzo[20];
	char    quantita[10];
	int		righeStampate;

	for(i=0; i<nPrezziari; i++)
	{
		// controlla se nel prezziario i esiste almeno un'ordinazione
		int ordineValido = 0;
		for(j=0; j<Menu[i].m_nVoci; j++)
			if(listaOrdini[i].m_articolo[j].m_quantita)
			{
				ordineValido = 1;
				break;
			}

		if(ordineValido)
		{
			righeStampate = 0;

			if(primaStampa)
			{
				// margine superiore
				for(int r=0 ;r<PRN_MARGINE_SUP; r++)
					fprintf(STDPRN, "%c", LF);

				primaStampa = 0;
			}

			righeStampate = PRN_MARGINE_SUP;

			// intestazione
			fprintf(STDPRN, "%c", ESC);		// setta carattere
			fprintf(STDPRN, "E");			// grassetto

			strcpy(riga, "");
			for(int k=0; k<PRN_MARGINE_SX; k++)
				strcat(riga, " ");

			strcpy(buffer, INTESTAZIONE_SCONTRINO);
			int addChars = (PRN_MAX_COLONNE - strlen(buffer) - PRN_MARGINE_SX)/2;
			for(int c=0; c<addChars - 1; c++)
				strcat(riga, CARATTERE_INTESTAZIONE);
			strcat(riga, " ");
			strcat(riga, buffer);
			strcat(riga, " ");
			while(strlen(riga) < PRN_MAX_COLONNE)
				strcat(riga, CARATTERE_INTESTAZIONE);
			fprintf(STDPRN, riga);
			fprintf(STDPRN, "%c", LF);

			righeStampate++;

			strcpy(riga, "");
			for(k=0; k<PRN_MARGINE_SX; k++)
				strcat(riga, " ");

			strcpy(buffer, titoloSecondaRiga);
			addChars = (PRN_MAX_COLONNE - strlen(buffer) - PRN_MARGINE_SX)/2;
			for(c=0; c<addChars - 1; c++)
				strcat(riga, CARATTERE_INTESTAZIONE);
			strcat(riga, " ");
			strcat(riga, buffer);
			strcat(riga, " ");
			while(strlen(riga) < PRN_MAX_COLONNE)
				strcat(riga, CARATTERE_INTESTAZIONE);
			fprintf(STDPRN, riga);
			fprintf(STDPRN, "%c", LF);

			righeStampate++;

			fprintf(STDPRN, "%c", ESC);		// ripristina carattere
			fprintf(STDPRN, "F");			// normale

			// nome menu
			fprintf(STDPRN, "%c", LF);

			righeStampate++;

			strcpy(riga, "");
			for(k=0; k<PRN_MARGINE_SX; k++)
				strcat(riga, " ");

			addChars = (PRN_MAX_COLONNE - strlen(Menu[i].m_nome) - PRN_MARGINE_SX)/2;
			for(c=0; c<addChars - 1; c++)
				strcat(riga, "-");
			strcat(riga, " ");
			strcpy(buffer, Menu[i].m_nome);
			strcat(riga, strupr(buffer));
			strcat(riga, " ");
			while(strlen(riga) < PRN_MAX_COLONNE)
				strcat(riga, "-");
			fprintf(STDPRN, riga);
			fprintf(STDPRN, "%c", LF);

			righeStampate++;

			// articoli (nome articolo, quantita, prezzo unitario)
			for(j=0; j<Menu[i].m_nVoci; j++)
			{
				if(listaOrdini[i].m_articolo[j].m_quantita > 0)
				{
					strcpy(riga, "");
					for(k=0; k<PRN_MARGINE_SX; k++)
						strcat(riga, " ");

					strcat(riga, listaOrdini[i].m_articolo[j].m_nome);

					strcpy(quantita, itoa(listaOrdini[i].m_articolo[j].m_quantita, buffer, 10));
					strcpy(prezzo, InserisciPunti(ultoa(Menu[i].m_prezzo[j].m_prezzo, buffer, 10)));

					strcat(riga, " ");
					while(strlen(riga) < PRN_MAX_COLONNE - 4 - strlen(quantita) - strlen(prezzo))
					{
						strcat(riga, ".");
					}
					strcat(riga, " ");
					strcat(riga, quantita);
					strcat(riga, " x ");
					strcat(riga, prezzo);

					if(righeStampate > PRN_MAX_RIGHE-3)
					{
						fprintf(STDPRN, "%c", LF);

						strcpy(buffer, "");
						for(k=0; k<PRN_MARGINE_SX; k++)
							strcat(buffer, " ");

						strcat(buffer, "continua sotto...");
						fprintf(STDPRN, buffer);
						fprintf(STDPRN, "%c", FF);

						righeStampate = 0;

						for(k=0 ;k<PRN_MARGINE_SUP; k++)
						{
							fprintf(STDPRN, "%c", LF);
							righeStampate++;
						}
					}


					fprintf(STDPRN, riga);
					fprintf(STDPRN, "%c", LF);
					righeStampate++;
				}
			}
//			fprintf(STDPRN, "%c", LF);

			if((listaOrdini[0].m_tipoOrdine == NULL)
				|| (strlen(listaOrdini[0].m_tipoOrdine)==0))
			{
				strcpy(prezzo, InserisciPunti(ultoa(totaliParziali[i], buffer, 10)));
				strcpy(buffer, "Totale .... L. ");
				strcat(buffer, prezzo);
			}
			else
			{
				strcpy(buffer, OPZIONE_GRATIS);
				strcat(buffer, ": ");
				strcat(buffer, listaOrdini[0].m_tipoOrdine);

				fprintf(STDPRN, "%c", ESC);		// setta carattere
				fprintf(STDPRN, "E");			// grassetto
			}

			strcpy(riga, "");
			while(strlen(riga) < PRN_MAX_COLONNE - strlen(buffer))
				strcat(riga, " ");
			strcat(riga, buffer);
			fprintf(STDPRN, riga);
			fprintf(STDPRN, "%c", LF);
			fprintf(STDPRN, "%c", LF);

			fprintf(STDPRN, "%c", ESC);		// ripristina carattere
			fprintf(STDPRN, "F");			// normale


			// data e ora ordinazione
			strcpy(riga, "");
			for(k=0; k<PRN_MARGINE_SX; k++)
				strcat(riga, " ");

			strcat(riga, "(");
			strcat(riga, listaOrdini[i].m_data);
			strcat(riga, "  ");
			strcat(riga, listaOrdini[i].m_ora);
			strcat(riga, ")   ");

			fprintf(STDPRN, riga);
			fprintf(STDPRN, "%c", FF);

			if(!primaStampa)
			{
				// margine superiore scontrino successivo
				for(int r=0 ;r<PRN_MARGINE_SUP; r++)
					fprintf(STDPRN, "%c", LF);
			}
		}
	}
}





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                 I N T E R F A C C I A   U T E N T E
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// AbilitaCursore
void AbilitaCursore(void)
{
union REGS a,b;

	a.h.ah = 0x0f;				// funzione BIOS n. 0Fh, la quale
	int86(0x10,&a,&b);			// ritorna la pagina video attiva
								// all'interno del registro <bh>.

	a.h.ah = 0x03;				// funzione BIOS n.03h,  che
	a.h.bh = b.h.bh;			// ritorna lo stato del cur-
	int86(0x10,&a,&b);			// sore nei registri <ch,cl>

	a.h.ah = 0x01;				// funzione BIOS n.01h
	a.h.cl = b.h.cl;
	a.h.ch = b.h.ch & 0xdf;		// D5 = 0 ==> Cursore Abilitato
	int86(0x10,&a,&b);
}

/////////////////////////////////////////////////////////////////////////////
// DisabilitaCursore
void DisabilitaCursore(void)
{
union REGS a,b;

	a.h.ah = 0x0f;				// funzione BIOS n. 0Fh, la quale
	int86(0x10,&a,&b);			// ritorna la pagina video attiva
								// all'interno del registro <bh>.

	a.h.ah = 0x03;				// funzione BIOS n.03h,  che
	a.h.bh = b.h.bh;			// ritorna lo stato del cur-
	int86(0x10,&a,&b);			// sore nei registri <ch,cl>

	a.h.ah = 0x01;				// funzione BIOS n.01h
	a.h.cl = b.h.cl;
	a.h.ch = b.h.ch | 0x20;		// D5 = 1 ==> Cursore Disabilitato
	int86(0x10,&a,&b);
}

/////////////////////////////////////////////////////////////////////////////
// Conferma
int Conferma(char* linea1, char* linea2)
{
	DisabilitaCursore();
	char* messaggio = " Si     No ";
	int lungMsg = strlen(messaggio);

	int altezza = 1;
	if (strlen(linea1)>0)
		altezza += 2;
	if (strlen(linea2)>0)
		altezza += 2;

	int larghezza = (strlen(linea1)>lungMsg) ? strlen(linea1) : lungMsg;
	larghezza = (strlen(linea2)>larghezza) ? strlen(linea2) : larghezza;
	larghezza += 2;

	int riga = (RIGHE - altezza)/2 - 1;
	int colonna = (COLONNE - larghezza)/2 - 1;

	gotoxy(colonna,riga);
	putch(ALTO_SX);
	for (int i=0; i<larghezza; i++)
		putch(ORIZZONTALE);
	putch(ALTO_DX);
	riga++;

	if (strlen(linea1)>0)
	{
		gotoxy(colonna,riga);
		putch(VERTICALE);
		for (int i=0; i<larghezza; i++)
			putch(' ');
		gotoxy(colonna + (larghezza-strlen(linea1))/2 + 1,riga);
		cputs(linea1);
		gotoxy(colonna+larghezza+1,riga);
		putch(VERTICALE);
		riga++;

		gotoxy(colonna,riga);
		putch(VERTICALE);
		for (i=0; i<larghezza; i++)
			putch(' ');
		putch(VERTICALE);
		riga++;
	}

	if (strlen(linea2)>0)
	{
		gotoxy(colonna,riga);
		putch(VERTICALE);
		for (i=0; i<larghezza; i++)
			putch(' ');
		gotoxy(colonna + (larghezza-strlen(linea2))/2 + 1,riga);
		cputs(linea2);
		gotoxy(colonna+larghezza+1,riga);
		putch(VERTICALE);
		riga++;

		gotoxy(colonna,riga);
		putch(VERTICALE);
		for (i=0; i<larghezza; i++)
			putch(' ');
		putch(VERTICALE);
		riga++;
	}

	gotoxy(colonna,riga);
	putch(VERTICALE);
	for (i=0; i<larghezza; i++)
		putch(' ');
	putch(VERTICALE);
	gotoxy(colonna + (larghezza-lungMsg)/2 + 1,riga);
	cputs(messaggio);
	riga++;

	gotoxy(colonna,riga);
	putch(BASSO_SX);
	for (i=0; i<larghezza; i++)
		putch(ORIZZONTALE);
	putch(BASSO_DX);


	char ch;
	do {
		ch = getch();
	} while ((ch!='s') && (ch!='S') && (ch!='n') && (ch!='N'));

	AbilitaCursore();
	return((ch=='s') || (ch=='S'));
}

/////////////////////////////////////////////////////////////////////////////
// ScriviTitolo
void ScriviTitolo()
{
	// Ricordati di modificare RIGHE_TITOLO secondo le evenienze,
	// semmai ti venisse in mente di cambiare questa funzione....
	gotoxy(1,1);
	putch(ALTO_SX);
	for (int i=0; i<COLONNE-2; i++)
		putch(ORIZZONTALE);
	putch(ALTO_DX);

	// Scrivi il titolo standard
	gotoxy(1,2);
	putch(VERTICALE);
	gotoxy((COLONNE - strlen(TESTO_TITOLO))/2 + 1,2);
	cputs(TESTO_TITOLO);
	gotoxy(COLONNE,2);
	putch(VERTICALE);

	// Scrivi la seconda riga
	gotoxy(1,3);
	putch(VERTICALE);
	gotoxy((COLONNE - strlen(titoloSecondaRiga))/2 + 1,3);
	cputs(titoloSecondaRiga);
	gotoxy(COLONNE,3);
	putch(VERTICALE);

	gotoxy(1,RIGHE_TITOLO);
	putch(BASSO_SX);
	for (i=0; i<COLONNE-2; i++)
		putch(ORIZZONTALE);
	putch(BASSO_DX);
}

/////////////////////////////////////////////////////////////////////////////
// ScriviMessaggioPiePagina
void ScriviMessaggioPiePagina()
{
	// Ricordati di modificare RIGHE_PIEPAGINA secondo le evenienze,
	// semmai ti venisse in mente di cambiare il codice di questa funzione...
	gotoxy(1,RIGHE-1);
	cputs(TESTO_PIEPAGINA);
}

/////////////////////////////////////////////////////////////////////////////
// VisualizzaMaschera
void VisualizzaMaschera(int menu)
{
	// Menu valido?
	if ((menu<0) || (menu>=nPrezziari))
		return;

	clrscr();
	ScriviTitolo();
	DisabilitaCursore();

	char ch;
	int uscita = 0;
	int i, riga, art, selezione = 0;
	char chToStr[2]; chToStr[1] = '\0';

	// Quantita' introdotta
	char strQta[LUNG_CAMPO_QUANTITA + 1]; strQta[0] = '\0';

	do {
		// Stampa ordinazione attuale
		art = 0;
		char buffer[LUNG_CAMPO_ARTICOLO + 1];
		riga = (RIGHE - RIGHE_TITOLO - Menu[menu].m_nVoci)/2 + RIGHE_TITOLO;
		if (riga<=0)
			riga =  RIGHE_TITOLO + 3;

		// Scrivi l'intestazione della tabella
		gotoxy(COLONNA_ARTICOLO,riga-2);
		cputs(NOME_COLONNA_ARTICOLO);
		gotoxy(COLONNA_PREZZO,riga-2);
		cputs(NOME_COLONNA_PREZZO);
		gotoxy(COLONNA_QUANTITA,riga-2);
		cputs(NOME_COLONNA_QUANTITA);
		gotoxy(COLONNA_ARTICOLO,riga-1);
		for (i=0; i<(COLONNA_QUANTITA - COLONNA_ARTICOLO
									  + LUNG_CAMPO_QUANTITA); i++)
			putch('-');

		while ((art<Menu[menu].m_nVoci) && (riga<RIGHE-RIGHE_PIEPAGINA))
		{
			if (art==selezione)
			{
				textcolor(CARTA);
				textbackground(PENNA);
			}
			else
			{
				textcolor(PENNA);
				textbackground(CARTA);
			}

			// Scrivi il nome dell'articolo
			strcpy(buffer,Menu[menu].m_prezzo[art].m_nome);
			for (i=strlen(buffer); i<LUNG_CAMPO_ARTICOLO; i++)
				strcat(buffer," ");
			gotoxy(COLONNA_ARTICOLO,riga);
			cputs(buffer);

			// Scrivi il prezzo
			ultoa(Menu[menu].m_prezzo[art].m_prezzo,buffer,10);
			buffer[LUNG_CAMPO_PREZZO] = '\0';
			gotoxy(COLONNA_PREZZO,riga);
			cputs(buffer);
			for (i=strlen(buffer); i<LUNG_CAMPO_PREZZO; i++)
				putch(' ');

			// Stampa la quantita'
			itoa(listaOrdini[menu].m_articolo[art].m_quantita,buffer,10);
			buffer[LUNG_CAMPO_QUANTITA] = '\0';
			gotoxy(COLONNA_QUANTITA,riga);
			cputs(buffer);
			for (i=strlen(buffer); i<LUNG_CAMPO_QUANTITA; i++)
				putch(' ');

			art++;
			riga++;
		}

		textcolor(PENNA);
		textbackground(CARTA);

		// Cosa ha scelto l'utente?
		ch = getch();

		// Freccie?
		if (ch==0)
		{
			ch = getch();
			switch (ch) {
				case FRECCIA_SU		: if (strlen(strQta)>0)
										strQta[0] = '\0';

									  selezione--;
									  if (selezione<0)
										selezione = Menu[menu].m_nVoci-1;

									  break;
				case FRECCIA_GIU	: if (strlen(strQta)>0)
										strQta[0] = '\0';

									  selezione++;
									  if (selezione>=Menu[menu].m_nVoci)
										selezione = 0;
									  break;
			}
		}

		// Cifra?
		if ((ch>='0') && (ch<='9'))
		{
			if (strlen(strQta)<LUNG_CAMPO_QUANTITA)
			{
				// Attacca
				chToStr[0] = ch;
				strcat(strQta,chToStr);
				listaOrdini[menu].m_articolo[selezione].m_quantita
														 = atoi(strQta);
			}
		}

		// Cancella?
		if ((ch==DEL) && (strlen(strQta)>0))
		{
			strQta[strlen(strQta) - 1] = '\0';
			listaOrdini[menu].m_articolo[selezione].m_quantita = atoi(strQta);
		}

		// Terminato?
		if (ch==RETURN)
			uscita = 1;

		// Butto via tutto?
		if (ch==ESC)
		{
			uscita = 1;
			selezione = -1;
		}

	} while (!uscita);

	if (selezione!=-1)
	{
		if (Conferma("Confermi l'ordine?"))
		{
			// Che ora e'?
			struct tm *time_now;
			time_t secs_now;

			tzset();
			time(&secs_now);
			time_now = localtime(&secs_now);
			strftime(listaOrdini[menu].m_ora,sizeof(stringa),
											"%H:%M:%S",time_now);
			strftime(listaOrdini[menu].m_data,sizeof(stringa),
											"%d-%m-%Y",time_now);
			// Calcola il totale
			totaliParziali[menu] = 0;
			for (int i=0; i<Menu[menu].m_nVoci; i++)
				totaliParziali[menu] += (unsigned long)
						Menu[menu].m_prezzo[i].m_prezzo*
						listaOrdini[menu].m_articolo[i].m_quantita;

			return;
		}

	}

	// Qualcosa e' andato storto...
	totaliParziali[menu] = 0;
	for (i=0; i<MAX_CATEGORIE; i++)
		listaOrdini[menu].m_articolo[i].m_quantita = 0;

	AbilitaCursore();
	return;
}

/////////////////////////////////////////////////////////////////////////////
// StampaScontrino
void StampaScontrino()
{
	totaleOrdine = 0;
	for (int i=0; i<MAX_PREZZIARI; i++)
	{
		totaleOrdine += totaliParziali[i];
		listaOrdini[i].m_tipoOrdine[0] = '\0';
	}

	if (totaleOrdine==0)
		return;

	// Costruisci la stringa del totale
	strcpy(strTotaleOrdine,"");

	char buffer1[80];
	char buffer2[80];
	ultoa(totaleOrdine,buffer1,10);

	// Metti i punti ogni 3 cifre
	int primeCifre = strlen(buffer1) % 3;
	strncat(strTotaleOrdine,buffer1,primeCifre);

	int pos = primeCifre;
	while (pos<strlen(buffer1))
	{
		if (pos>0)
			strcat(strTotaleOrdine,".");

		strncat(strTotaleOrdine,&buffer1[pos],3);
		pos += 3;
	}

	// Mostra il totale e chiedi conferma
	strcpy(buffer1,"ORDINE N.");
	strcat(buffer1,ultoa(numeroOrdine + 1,buffer2,10));
	strcat(buffer1,", TOTALE = ");
	strcat(buffer1,strTotaleOrdine);
	strcat(buffer1," lire.");

	if (Conferma(buffer1,"Tutto OK?"))
	{
		// Stampa l'ordinazione
		StampaOrdinazioni();

		// Registra l'ordinazione
		AggiornaArchivi();
	}

	// Azzera i totali parziali
	for (i=0; i<MAX_PREZZIARI; i++)
	{
		totaliParziali[i] = 0;
		for (int j=0; j<MAX_CATEGORIE; j++)
			listaOrdini[i].m_articolo[j].m_quantita = 0;
	}
}

void StampaScontrinoGratis()
{
	totaleOrdine = 0;
	for (int i=0; i<MAX_PREZZIARI; i++)
	{
		totaleOrdine += totaliParziali[i];
		listaOrdini[i].m_tipoOrdine[0] = '\0';
	}

	if (totaleOrdine==0)
		return;

	// Nessun costo per un'ordinazione gratis
	totaleOrdine = 0;
	for (i=0; i<MAX_PREZZIARI; i++)
		totaliParziali[i] = 0;

	// Chiedi il tipo di ordinazione
	char buffer[MAX_LUNG_DESCR_ORDINE];

	// Disegna la finestra per l'immissione del tipo di ordinazione
	int riga = 9;
	int colonna = 14;
	int larghezza = 50;
	char linea1[] = OPZIONE_GRATIS;
	char linea2[] = " descrizione:";

	gotoxy(colonna,riga);
	putch(ALTO_SX);
	for (i=0; i<larghezza; i++)
		putch(ORIZZONTALE);
	putch(ALTO_DX);
	riga++;

	if (strlen(linea1)>0)
	{
		gotoxy(colonna,riga);
		putch(VERTICALE);
		putch(' ');
		gotoxy(colonna+2,riga);
		cputs(linea1);
		for (int i=strlen(linea1); i<larghezza; i++)
			putch(' ');
		gotoxy(colonna+larghezza+1,riga);
		putch(VERTICALE);
		riga++;

		gotoxy(colonna,riga);
		putch(VERTICALE);
		for (i=0; i<larghezza; i++)
			putch(' ');
		putch(VERTICALE);
		riga++;
	}

	if (strlen(linea2)>0)
	{
		gotoxy(colonna,riga);
		putch(VERTICALE);
		putch(' ');
		gotoxy(colonna+2,riga);
		cputs(linea2);
		for (int i=strlen(linea2); i<larghezza; i++)
			putch(' ');
		gotoxy(colonna+larghezza+1,riga);
		putch(VERTICALE);
		riga++;

		gotoxy(colonna,riga);
		putch(VERTICALE);
		for (i=0; i<larghezza; i++)
			putch(' ');
		putch(VERTICALE);
		riga++;
	}

	gotoxy(colonna,riga);
	putch(BASSO_SX);
	for (i=0; i<larghezza; i++)
		putch(ORIZZONTALE);
	putch(BASSO_DX);

	// Disegna il campo di scrittura
	textcolor(CARTA);
	textbackground(PENNA);
	gotoxy(colonna+strlen(linea2)+3,riga-2);
	for (i=0;i<=MAX_LUNG_DESCR_ORDINE;i++)
		putch(' ');

	gotoxy(colonna+strlen(linea2)+3,riga-2);

	// Richiedi la stringa
	char ch[2];
	int lung = 0;
	ch[1] = '\0';
	ch[0] = getch();

	while((ch[0]!=RETURN) && (lung<MAX_LUNG_DESCR_ORDINE))
	{
		if (isprint(ch[0]))
		{
			buffer[lung] = ch[0];
			putch(ch[0]);
			lung++;
		}
		else
			if ((ch[0]==BK_SPACE) && (lung>0))
			{
				buffer[lung] = ' ';
				putch(BK_SPACE);
				putch(' ');
				putch(BK_SPACE);
				lung--;
			}

		ch[0] = getch();
	}

	buffer[lung] = '\0';

	textcolor(PENNA);
	textbackground(CARTA);

	if (strlen(buffer)==0)
		strcpy(buffer,OPZIONE_GRATIS);

	// Imposta il tipo di ordinazione
	for (i=0; i<MAX_PREZZIARI; i++)
			listaOrdini[i].m_tipoOrdine = buffer;

	// Stampa lo scontrino
	char help[80];
	strcpy(help,OPZIONE_GRATIS);
	strcat(help,": ");
	strcat(help,buffer);
	if (Conferma(help,"Tutto OK?"))
	{
		// Stampa l'ordinazione
		StampaOrdinazioni();

		// Registra l'ordinazione
		AggiornaArchivi();
	}

	// Annulla l'ordinazione
	for (i=0; i<MAX_PREZZIARI; i++)
		for (int j=0; j<MAX_CATEGORIE; j++)
			listaOrdini[i].m_articolo[j].m_quantita = 0;
}
/////////////////////////////////////////////////////////////////////////////
// StampaMenuGenerale
int StampaMenuGenerale()
{
	char ch;
	int uscita = 0;
	int selezione = 0;

	clrscr();
	ScriviTitolo();
	ScriviMessaggioPiePagina();

	DisabilitaCursore();

	do {
		textcolor(PENNA);
		textbackground(CARTA);

		int riga = (RIGHE - RIGHE_TITOLO -
					RIGHE_PIEPAGINA - nPrezziari)/2 + RIGHE_TITOLO - 1;
		int maxLung = strlen(OPZIONE_STAMPA);
		if (strlen(OPZIONE_GRATIS)>maxLung)
			maxLung = strlen(OPZIONE_GRATIS);

		for (int i=0; i<nPrezziari; i++)
			if (strlen(Menu[i].m_nome)>maxLung)
				maxLung = strlen(Menu[i].m_nome);

		maxLung += 2;	// Spazio in testa e coda
		int colonna = (COLONNE - maxLung)/2 - 1;

		// Disegna la cornicetta in alto
		gotoxy(colonna,riga);
		putch(ALTO_SX);
		for(i=0; i<maxLung; i++)
			putch(ORIZZONTALE);
		putch(ALTO_DX);
		riga++;

		// Disegna le opzioni
		stringa opzione;

		for (int opz=0; opz<=nPrezziari+1; opz++)
		{
			gotoxy(colonna,riga);

			putch(VERTICALE);
			if (selezione==opz)
			{
				textcolor(CARTA);
				textbackground(PENNA);
			}

			strcpy(opzione," ");
			if (opz<nPrezziari)
				strcat(opzione,Menu[opz].m_nome);
			else
				if (opz==nPrezziari)
					strcat(opzione,OPZIONE_STAMPA);
				else
					strcat(opzione,OPZIONE_GRATIS);

			while (strlen(opzione)<maxLung)
				strcat(opzione," ");

			cputs(opzione);
			if (selezione==opz)
			{
				textcolor(PENNA);
				textbackground(CARTA);
			}

			putch(VERTICALE);
			riga++;
		}

		// Disegna la cornicetta in basso
		gotoxy(colonna,riga);
		putch(BASSO_SX);
		for(i=0; i<maxLung; i++)
			putch(ORIZZONTALE);
		putch(BASSO_DX);

		// Cosa ha scelto l'utente?
		ch = getch();

		// Freccie?
		if (ch==0)
		{
			ch = getch();
			switch (ch) {
				case FRECCIA_SU		: selezione--;
									  if (selezione<0)
										selezione = nPrezziari+1;
									  break;
				case FRECCIA_GIU	: selezione++;
									  if (selezione>nPrezziari+1)
										selezione = 0;
									  break;
			}
		}

		// Selezione?
		if (ch==RETURN)
			uscita = 1;

		// Fine Sessione?
		if (ch==ESC)
		{
			uscita = 1;
			selezione = -1;
		}

	} while (!uscita);

	AbilitaCursore();
	return selezione;
}





/////////////////////////////////////////////////////////////////////////////
//                          P R I N C I P A L E
/////////////////////////////////////////////////////////////////////////////

void main(int argc, char* argv[])
{
	clrscr();

	// Carica il codice dell'ultima ordinazione
	LeggiConfigurazione();

	// L'utente ha passato il nome del file del prezziario?
	if (argc>1)
		strcpy(nomeFilePrezziario,argv[1]);
	else
		strcpy(nomeFilePrezziario,NOME_FILE_PREZZIARIO);

	// L'utente ha passato il nome del direttorio dei file di archivio?
	if (argc>2)
	{
		strcpy(nomeDirettorioArchivi,argv[2]);
		if (nomeDirettorioArchivi[strlen(nomeDirettorioArchivi)]!='\\')
			strcat(nomeDirettorioArchivi,"\\");
	}
	else
		strcpy(nomeDirettorioArchivi,NOME_DIRETTORIO_ARCHIVI);

	// Leggi il prezziario giusto
	if (!LeggiPrezziario())
	{
		puts("ERRORE: Non trovo il prezziario...\n");
		return;
	}

	if (nPrezziari==0)
	{
		puts("ERRORE: Non riesco a leggere il prezziario.");
		puts("        Verifica che le regole sintattiche siano rispettate.\n");
		return;
	}

	// Azzera i totali parziali
	for (int i=0; i<MAX_PREZZIARI; i++)
		totaliParziali[i] = 0;

	// Inizializza la lista degli ordini
	for (int menu=0; menu<nPrezziari; menu++)
		for (i=0; i<MAX_CATEGORIE; i++)
			strcpy(listaOrdini[menu].m_articolo[i].m_nome,
							Menu[menu].m_prezzo[i].m_nome);

	// Determina i nomi dei file di archivio
	ComponiNomiFileArchivio();
//	{
//		puts("ERRORE: Non riesco a costruire i file di archivio.");
//		puts("        Verifica che il direttorio di salvataggio esista.\n");
//		return;
//	}


	ImpostaStampante();


	// Ciclo principale
	do {
		int comando = StampaMenuGenerale();

		while ((comando>=0) && (comando<=nPrezziari+1))
		{
			if (comando==nPrezziari+1)
			{
				StampaScontrinoGratis();
				numeroOrdine++;
			}

			if (comando==nPrezziari)
			{
				StampaScontrino();
				numeroOrdine++;
			}

			VisualizzaMaschera(comando);
			comando = StampaMenuGenerale();

			// Salva il codice dell'ultima ordinazione
			if (!SalvaConfigurazione())
			{
				puts("ERRORE: Non sono riuscito a salvare la configurazione...");
				puts("        Verifica che ci sia spazio sufficiente sul disco\n");
			}
		}
	} while (!Conferma("Uscire dal Programma?"));

	// Saluti
	clrscr();

	puts("(C) 1995 by Jonni & Zula Sottuer Aus!\n");
	puts("E' stato bellissimo!   Arrivederci...\n");

	return;
}