/* pelosano.h     - Dichiarazioni delle Costanti e delle Strutture  -   */

/* Questo fighissimo programma, scritto da quei matti di Jonni e Zula,  */
/* dovrebbe gestire i movimenti di cassa per la festa dell'Azalea e del */
/* Rododendro che si tiene  ogni  anno  presso  l'azienda  agricola  di */
/* solidarieta' sociale "Il Melograno",  sito in via Carbonaria "numaar */
/* quarante" a Rizzolo di Reana.                                        */
/*                                                                      */
/*                                                                      */
/* Il codice e' stato scritto in quel di Rizzolo, nel Marzo del '95.    */
/* (Per la precisione, tutto ebbe inizio il 09.03.95 alle 09:32:34).    */



//        *************************
//        *   Strutture di Dati   *
//        *************************


// --- Costanti globali ---

// Dimensioni dello schermo
#define RIGHE				25
#define COLONNE				80

// Dimensioni degli archivi
#define MAX_LUNG_NOMI	32
#define MAX_CATEGORIE	20
#define MAX_PREZZIARI    8

// Mascheratura del prezziario
// N.B. per fini grafici, e'  consigliabile  porre  la  lunghezza
//      di un campo maggiore o uguale alla lunghezza del suo nome
#define COLONNA_ARTICOLO		10
#define LUNG_CAMPO_ARTICOLO		35
#define NOME_COLONNA_ARTICOLO	"Articolo"
#define COLONNA_PREZZO			45
#define LUNG_CAMPO_PREZZO		15
#define NOME_COLONNA_PREZZO		"Prezzo"
#define COLONNA_QUANTITA		60
#define LUNG_CAMPO_QUANTITA		10
#define NOME_COLONNA_QUANTITA	"Quantita"

// Titolo e Pie' Pagina
#define RIGHE_TITOLO		 4
#define TESTO_TITOLO   		 "IL MELOGRANO - Coop. Agricola di Solidarieta' Sociale"
#define TESTO_TITOLO_2aRIGA	 ""
#define RIGHE_PIEPAGINA		 1
#define TESTO_PIEPAGINA		"(C) 1995 by Quei due Matti di Jonni e Zula..."

// Margini delle finestre
#define ALTO_SX			''
#define ALTO_DX			''
#define BASSO_SX		''
#define BASSO_DX		''
#define VERTICALE		''
#define ORIZZONTALE		''

// Colori (Monocromatico)
#define CARTA			BLACK
#define PENNA			LIGHTGRAY

// Tasti piu' usati
#define TAB				0x09
#define ESC				0x1b
#define INS				0x52
#define DEL				0x53
#define	A_CAPO			0x0a
#define	RETURN			0x0d
#define BK_SPACE		0x08
#define FRECCIA_SX		0x4b
#define FRECCIA_DX		0x4d
#define FRECCIA_SU		0x48
#define FRECCIA_GIU		0x50

#define OPZIONE_STAMPA			"STAMPA SCONTRINO"
#define OPZIONE_GRATIS			"ORDINAZIONE INTERNA"
#define MAX_LUNG_DESCR_ORDINE	32

// Gestione dei files
#define MAX_LUNG_NOME_FILE			128
#define NOME_FILE_PREZZIARIO		"c:\\melo.prz"
#define NOME_FILE_CONFIGURAZIONE	"c:\\melo.cfg"

#define SUFFISSO_CODICE_INTERNO 	"I"
#define NOME_FILE_ARCHIVI			"melo"
#define NOME_DIRETTORIO_ARCHIVI		"c:\\"
#define ESTENSIONE_FILE_MAGAZZINO	".mag"
#define ESTENSIONE_FILE_TOTALI		".tot"

#define	NOME_ULTIMO_ORDINE			"ULTIMO ORDINE:"
#define NOME_SECONDA_RIGA			"TITOLO:"
#define NOME_CATEGORIA				"ELENCO:"

// Carattere, non stringa!!
#define SEPARATORE		TAB

// Caratteri di controllo della stampante (Epson FX)
#define NUL							0x00
#define HT							0x09
#define	LF							0x0A
#define VT							0x0B
#define	FF							0x0C
#define INIZIO_COMPRESSO			0x0F
#define FINE_COMPRESSO				0x12

// Parametri di stampa dello scontrino
#define CARATTERE_INTESTAZIONE		"*"
#define PRN_MAX_COLONNE				53
#define PRN_MAX_RIGHE				23
#define PRN_MAX_LUNG_NOMI			20
#define PRN_MARGINE_SX				6
#define PRN_MARGINE_SUP				4
#define PRN_MARGINE_INF				0
#define INTESTAZIONE_SCONTRINO		"Il Melograno"
#define LUNGHEZZA_SCONTRINO			3				// pollici

#define STDPRN						stdprn





// --- Tipi di Dati Semplici ---

typedef char stringa[MAX_LUNG_NOMI + 1];

typedef struct xPrezzo {
			long 		m_prezzo;
			stringa		m_nome;
		} Prezzo;

typedef struct xQuantita {
			stringa		m_nome;
			int			m_quantita;
		} Quantita;


// --- Strutture Globali ---

typedef struct xPrezziario {
			stringa	m_nome;
			int		m_nVoci;
			Prezzo	m_prezzo[MAX_CATEGORIE];
		} Prezziario;

typedef struct xOrdinazione {
		stringa		m_ora;
		stringa		m_data;
		char*		m_tipoOrdine;				// descrizione ordine gratuito
		Quantita	m_articolo[MAX_CATEGORIE];  // (NULL per ordini normali)
		} Ordinazione;



// --- Roba di Jonni ---
void ImpostaStampante();
void StampaOrdinazioni();


// --- Roba di Zula ---

void AttivaCursore();
void DisattivaCursore();
int  Conferma(char* linea1 = NULL, char* linea2 = NULL);

void ScriviTitolo();
int  StampaMenuGenerale();
void ScriviMessaggioPiePagina();
void VisualizzaMaschera(int menu);

int  AggiornaArchivi();
void StampaScontrino();
void StampaScontrinoGratis();

int  LeggiPrezziario();
void LeggiConfigurazione();
int  SalvaConfigurazione();
void ComponiNomiFileArchivio();
int  LeggiProssimaLinea(FILE* pFile, char* pBuffer);


